#include <mem.h>
#include "186COMM.h"
#define MAX_ERR_IDX 10

char CmdMsg[512]; //For storing the data of received command
unsigned int CmdLen; //For store the data length of recevie command
unsigned int SendMsgFlag,ErrorFlag;
void UserDPRAMIrqFunc(unsigned char INTT) //must be called
{
	int Ret;
	
	if (INTT==SEND_DPRAM_CMD){ //Check if commmand is received by using interrupt service routine
		Ret=DPRAMReceiveCmd(CmdMsg,&CmdLen);
		if (!Ret){
			SendMsgFlag=1; //Trigger the flag of sending message, then send message in loop function
		}
		else{
			if (Ret!=_NO_DPRAM_CMD) ErrorFlag=Ret; //Trigger the error flag, then show the error message in loop function
		}
	}
}

char ErrIdx,DefinedData[8]={0x12,0x23,0x34,0x45,0x56,0x67,0x78,0x89},IsNotFirstFlag[5]={0,0,0,0,0},Err[MAX_ERR_IDX];
unsigned long OldLowerTime[5],OldUpperTime[5];
unsigned long MaxValue[5]={0UL,0UL,0UL,0UL,0UL},
              MinValue[5]={0xffffffffUL,0xffffffffUL,0xffffffffUL,0xffffffffUL,0xffffffffUL},
              TotalTimePeriod[5]={0UL,0UL,0UL,0UL,0UL},TotalMsgCnt[5]={0UL,0UL,0UL,0UL,0UL};
void UserCANIrqFunc(unsigned char INTT)   //must be called
{

}
void UserInitFunc(void)    //must be called
{
	int Ret;
  Print("Receiving Testing is runnung...\r\n");
  DebugPrint("Receiving Testing is runnung...\r\n");
  SendMsgFlag=ErrorFlag=0; //initial the golbal variable
  Ret=CANConfig(1000000UL,0,0,0xffffffffUL,0x00000000UL); //Set baud to 125K, and filter is "passing all messages"
  if (Ret){
  	Print("Config error, error code=%d\r\n",Ret);
  	DebugPrint("Config error, error code=%d\r\n",Ret);
  }
  DebugPrint("Send command 'r' to start, and 'q' to stop\r\n");
	Print("Send command 'r' to start, and 'q' to stop\r\n");
}
void UserLoopFunc(void)    //must be called
{
	char Data[8],DataLen,Mode,RTR;
	int i,Ret;	
	unsigned long MsgID,UpperTime,LowerTime;
	
	if (SendMsgFlag){ //Check if the flag of sending message is triggered.
		switch(CmdMsg[0]){ //Check command type
			case 'r': 
			case 'R':
				EnableSJA1000(); //Let SJA1000 start to work.
				DebugPrint("Start to receive data\r\n");
				Print("Start to receive data\r\n");
				break;
			case 'q':
			case 'Q':
				DisableSJA1000();
				DebugPrint("Stop to receive data\r\n");
				Print("Stop to receive data\r\n");
				break;
		}
		SendMsgFlag=0;
	}
	
  Ret=GetCANMsg(&Mode,&MsgID,&RTR,&DataLen,Data,&UpperTime,&LowerTime); //Receiving CAN messages
  RefreshWDT();
	if (!Ret){
		DebugPrint("Mode=%d,ID=%08lx,RTR=%d,DLen=%d,",Mode,MsgID,RTR,DataLen); //print these messages on debug tools
		Print("Mode=%d,ID=%08lx,RTR=%d,DLen=%d,",Mode,MsgID,RTR,DataLen);
		if (RTR==0 && DataLen>0){
			DebugPrint("Data=");
			Print("Data=");
			for (i=0;i<DataLen;i++){
				DebugPrint("[%d]%02X,",i,Data[i]);
				Print("[%d]%02X,",i,Data[i]);
			}
		}
		DebugPrint("Time=%lu:%lu\r\n",UpperTime,LowerTime);
		Print("Time=%lu:%lu\r\n",UpperTime,LowerTime);
	}
	else{
		if (Ret!=_RX_SOFT_BUF_EMPTY){
			DebugPrint("Receive message error, error code=%d\r\n",Ret);
			Print("Receive message error, error code=%d\r\n",Ret);
			DebugPrint("Stop to receive data\r\n",Ret);
			Print("Receive message error, error code=%d\r\n",Ret);
	 		DisableSJA1000();
		}
	}
	RefreshWDT();
}